//+------------------------------------------------------------------+
//|                                                      Cot_v01.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#include <WebGet.mqh>
#property indicator_chart_window


string _download_cot()
{
   string StartMonth;
   string StartDay;
   
   datetime StartWeek = iTime(NULL,PERIOD_W1,0);  
   string StartYear  = TimeYear (StartWeek);
   
   if (TimeMonth(StartWeek)>10) 
     StartMonth = TimeMonth(StartWeek);
   else 
     StartMonth = "0" + TimeMonth(StartWeek);
     
   if (TimeDay(StartWeek)>10) 
     StartDay   = TimeDay(StartWeek);
   else 
     StartDay = "0" + TimeDay(StartWeek);
   
   string StartTime = StartYear + StartMonth + StartDay;  
   string WebAdress = "http://www.cftc.gov/dea/newcot/deacom.txt";
   string result = forextsd_com_webget(WebAdress);
   if(result != "") 
   {
   string CalName = "COT_"+StartYear+"-"+StartMonth+"-"+StartDay+".csv";
   Print(CalName," is OK");
   int handle=FileOpen(CalName,FILE_BIN |FILE_WRITE,' ');
         
      if(handle>0)
      {
      FileWrite(handle, result);
      FileClose(handle);
      }
   }
   else CalName = "";   

  return(CalName);      
}
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  _download_cot();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
/*
Average range in pips for the four majors, Eastern Time:
HOUR EUR/USD GBP/USD USD/CHF USD/JPY 
12 AM 10 11 15 14 
1 AM 13 15 20 15 
2 AM 21 25 30 20 
3 AM 23 29 34 21 
4 AM 20 27 29 20 
5 AM 17 25 26 18 
6 AM 17 24 26 18 
7 AM 18 24 27 19 
8 AM 26 31 39 25 
9 AM 24 29 36 23 
10 AM 30 34 45 26 
11 AM 24 29 36 22 
12 PM 20 25 31 19 
1 PM 16 19 25 15 
2 PM 16 18 24 15 
3 PM 12 15 19 12 
4 PM 9 11 14 10 
5 PM 9 9 12 9 
6 PM 8 9 12 11 
7 PM 10 11 15 15 
8 PM 11 11 16 17 
9 PM 10 10 14 15 
10 PM 10 12 16 13 
11 PM 8 9 11 11
===================
Average range in pips for the four majors:
Session EUR/USD GBP/USD USD/CHF USD/JPY 
Australia 65 77 99 66 
Japan 66 79 100 66 
UK - London 80 99 121 74 
USA - New York 67 78 101 60
===============================
Average range in pips for the four majors:
Day of Week EUR/USD GBP/USD USD/CHF USD/JPY 
Sunday 24 31 36 25 
Monday 92 110 141 95 
Tuesday 102 128 162 104 
Wednesday 101 123 158 106 
Thursday 83 98 121 77 
Friday 80 96 117 72
=======================
Day EUR/USD GBP/USD USD/CHF USD/JPY 
1 70 83 107 67 
2 89 108 128 82 
3 91 103 140 73 
4 78 78 112 76 
5 95 109 136 96 
6 96 112 148 90 
7 77 93 109 84 
8 84 105 119 75 
9 81 113 117 86 
10 76 87 117 79 
11 68 85 126 69 
12 76 78 110 66 
13 82 97 128 83 
14 66 100 107 80 
15 80 95 123 81
16 86 97 121 78 
17 88 111 129 86 
18 83 103 118 78 
19 86 105 133 97 
20 85 111 124 87 
21 76 108 115 86 
22 86 97 129 79 
23 87 103 130 84 
24 89 105 140 78 
25 65 85 107 61 
26 77 101 134 81 
27 73 90 123 76 
28 72 89 110 68 
29 80 92 111 80 
30 75 91 124 85 
31 80 90 125 79


*/
/*
1  MARKET AND EXCHANGE NAMES              =>WHEAT - CHICAGO BOARD OF TRADE
2  AS OF DATE IN FORM YYMMDD              =>70424
3  AS OF DATE IN FORM YYYY-MM-DD          =>4/24/2007
4  CFTC CONTRACT MARKET CODE              =>1602
5  CFTC MARKET CODE IN INITIALS           =>CBT,CCX,CME,CMX,E,KCBT,MGE,NYBT,NYME  
6  CFTC REGION CODE                       =>0
7  CFTC COMMODITY CODE                    =>1
~~~~~~~~~~~~~~~~~~~~~~~
8  OPEN INTEREST (ALL)
~~~~~~~~~~~~~~~~~~~~~~~
9   NONCOMMERCIAL POSITIONS-LONG (ALL)
10  NONCOMMERCIAL POSITIONS-SHORT (ALL)
11  NONCOMMERCIAL POSITIONS-SPREADING (ALL)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
12  COMMERCIAL POSITIONS-LONG (ALL)
13  COMMERCIAL POSITIONS-SHORT (ALL)
14  TOTAL REPORTABLE POSITIONS-LONG (ALL)
15  TOTAL REPORTABLE POSITIONS-SHORT (ALL)
16  NONREPORTABLE POSITIONS-LONG (ALL)
17  NONREPORTABLE POSITIONS-SHORT (ALL)
18  OPEN INTEREST (OLD)
19  NONCOMMERCIAL POSITIONS-LONG (OLD)
20  NONCOMMERCIAL POSITIONS-SHORT (OLD)
21  NONCOMMERCIAL POSITIONS-SPREADING (OLD)
22  COMMERCIAL POSITIONS-LONG (OLD)
23  COMMERCIAL POSITIONS-SHORT (OLD)
24  TOTAL REPORTABLE POSITIONS-LONG (OLD)
25  TOTAL REPORTABLE POSITIONS-SHORT (OLD)
26  NONREPORTABLE POSITIONS-LONG (OLD)
27  NONREPORTABLE POSITIONS-SHORT (OLD)
28  OPEN INTEREST (OTHER)
29  NONCOMMERCIAL POSITIONS-LONG (OTHER)
30  NONCOMMERCIAL POSITIONS-SHORT (OTHER)
31  NONCOMMERCIAL POSITIONS-SPREADING(OTHER)
32  COMMERCIAL POSITIONS-LONG (OTHER)
33  COMMERCIAL POSITIONS-SHORT (OTHER)
34  TOTAL REPORTABLE POSITIONS-LONG (OTHER)
35  TOTAL REPORTABLE POSITIONS-SHORT (OTHER)
36  NONREPORTABLE POSITIONS-LONG (OTHER)
37  NONREPORTABLE POSITIONS-SHORT (OTHER)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
38  CHANGE IN OPEN INTEREST (ALL)
39  CHANGE IN NONCOMMERCIAL-LONG (ALL)
40  CHANGE IN NONCOMMERCIAL-SHORT (ALL)
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
41  CHANGE IN NONCOMMERCIAL-SPREADING (ALL)
42  CHANGE IN COMMERCIAL-LONG (ALL)
43  CHANGE IN COMMERCIAL-SHORT (ALL)
44  CHANGE IN TOTAL REPORTABLE-LONG (ALL)
45  CHANGE IN TOTAL REPORTABLE-SHORT (ALL)
46  CHANGE IN NONREPORTABLE-LONG (ALL)
47  CHANGE IN NONREPORTABLE-SHORT (ALL)
48  % OF OPEN INTEREST (OI) (ALL)
49  % OF OI-NONCOMMERCIAL-LONG (ALL)
50  % OF OI-NONCOMMERCIAL-SHORT (ALL)
51  % OF OI-NONCOMMERCIAL-SPREADING (ALL)
52  % OF OI-COMMERCIAL-LONG (ALL)
53  % OF OI-COMMERCIAL-SHORT (ALL)
54  % OF OI-TOTAL REPORTABLE-LONG (ALL)
55  % OF OI-TOTAL REPORTABLE-SHORT (ALL)
56  % OF OI-NONREPORTABLE-LONG (ALL)
57  % OF OI-NONREPORTABLE-SHORT (ALL)
58  % OF OPEN INTEREST (OI) (OLD)
59  % OF OI-NONCOMMERCIAL-LONG (OLD)
60  % OF OI-NONCOMMERCIAL-SHORT (OLD)
61  % OF OI-NONCOMMERCIAL-SPREADING (OLD)
62  % OF OI-COMMERCIAL-LONG (OLD)
63  % OF OI-COMMERCIAL-SHORT (OLD)
64  % OF OI-TOTAL REPORTABLE-LONG (OLD)
65  % OF OI-TOTAL REPORTABLE-SHORT (OLD)
66  % OF OI-NONREPORTABLE-LONG (OLD)
67  % OF OI-NONREPORTABLE-SHORT (OLD)
68  % OF OPEN INTEREST (OI) (OTHER)
69  % OF OI-NONCOMMERCIAL-LONG (OTHER)
70  % OF OI-NONCOMMERCIAL-SHORT (OTHER)
71  % OF OI-NONCOMMERCIAL-SPREADING (OTHER)
72  % OF OI-COMMERCIAL-LONG (OTHER)
73  % OF OI-COMMERCIAL-SHORT (OTHER)
74  % OF OI-TOTAL REPORTABLE-LONG (OTHER)
75  % OF OI-TOTAL REPORTABLE-SHORT (OTHER)
76  % OF OI-NONREPORTABLE-LONG (OTHER)
77  % OF OI-NONREPORTABLE-SHORT (OTHER)
78  TRADERS-TOTAL (ALL)
79  TRADERS-NONCOMMERCIAL-LONG (ALL)
80  TRADERS-NONCOMMERCIAL-SHORT (ALL)
81  TRADERS-NONCOMMERCIAL-SPREADING (ALL)
82  TRADERS-COMMERCIAL-LONG (ALL)
83  TRADERS-COMMERCIAL-SHORT (ALL)
84  TRADERS-TOTAL REPORTABLE-LONG (ALL)
85  TRADERS-TOTAL REPORTABLE-SHORT (ALL)
86  TRADERS-TOTAL (OLD)
87  TRADERS-NONCOMMERCIAL-LONG (OLD)
88  TRADERS-NONCOMMERCIAL-SHORT (OLD)
89  TRADERS-NONCOMMERCIAL-SPREADING (OLD)
90  TRADERS-COMMERCIAL-LONG (OLD)
91  TRADERS-COMMERCIAL-SHORT (OLD)
92  TRADERS-TOTAL REPORTABLE-LONG (OLD)
93  TRADERS-TOTAL REPORTABLE-SHORT (OLD)
94  TRADERS-TOTAL (OTHER)
95  TRADERS-NONCOMMERCIAL-LONG (OTHER)
96  TRADERS-NONCOMMERCIAL-SHORT (OTHER)
97  TRADERS-NONCOMMERCIAL-SPREADING (OTHER)
98  TRADERS-COMMERCIAL-LONG (OTHER)
99  TRADERS-COMMERCIAL-SHORT (OTHER)
100  TRADERS-TOTAL REPORTABLE-LONG (OTHER)
101  TRADERS-TOTAL REPORTABLE-SHORT (OTHER)
102  CONCENTRATION-GROSS LT = 4 TDR-LONG (ALL) 
103 CONCENTRATION-GROSS LT ="4" TDR-SHORT (ALL) 
104 CONCENTRATION-GROSS LT ="8" TDR-LONG (ALL) 
105 CONCENTRATION-GROSS LT ="8" TDR-SHORT (ALL) 
106 CONCENTRATION-NET LT ="4" TDR-LONG (ALL) 
107 CONCENTRATION-NET LT ="4" TDR-SHORT (ALL) 
108 CONCENTRATION-NET LT ="8" TDR-LONG (ALL) 
109 CONCENTRATION-NET LT ="8" TDR-SHORT (ALL) 
110 CONCENTRATION-GROSS LT ="4" TDR-LONG (OLD) 
111 CONCENTRATION-GROSS LT ="4" TDR-SHORT (OLD) 
112 CONCENTRATION-GROSS LT ="8" TDR-LONG (OLD) 
113 CONCENTRATION-GROSS LT ="8" TDR-SHORT (OLD) 
114 CONCENTRATION-NET LT ="4" TDR-LONG (OLD) 
115 CONCENTRATION-NET LT ="4" TDR-SHORT (OLD) 
116 CONCENTRATION-NET LT ="8" TDR-LONG (OLD) 
117 CONCENTRATION-NET LT ="8" TDR-SHORT (OLD) 
118 CONCENTRATION-GROSS  LT ="4" TDR-LONG (OTHER) 
119 CONCENTRATION-GROSS LT ="4" TDR-SHORT(OTHER) 
120 CONCENTRATION-GROSS LT ="8" TDR-LONG (OTHER) 
121 CONCENTRATION-GROSS LT ="8" TDR-SHORT(OTHER) 
122 CONCENTRATION-NET LT ="4" TDR-LONG (OTHER) 
123 CONCENTRATION-NET LT ="4" TDR-SHORT (OTHER) 
124 CONCENTRATION-NET LT ="8" TDR-LONG (OTHER) 
125 CONCENTRATION-NET LT ="8" TDR-SHORT (OTHER) 
126 CONTRACT UNITS
127 CFTC CONTRACT MARKET CODE (QUOTES)
128 CFTC MARKET CODE IN INITIALS (QUOTES)
129 CFTC COMMODITY CODE (QUOTES)
*/